diff --git a/src/backend/optimizer/plan/analyzejoins.c b/src/backend/optimizer/plan/analyzejoins.c
index 881950e5264..5511597a997 100644
--- a/src/backend/optimizer/plan/analyzejoins.c
+++ b/src/backend/optimizer/plan/analyzejoins.c
@@ -1117,7 +1117,13 @@ reduce_unique_semijoins(PlannerInfo *root)
 static bool
 rel_supports_distinctness(PlannerInfo *root, RelOptInfo *rel)
 {
-	/* We only know about baserels ... */
+	/*
+	 * If UniqueKeys have already been deduced for the rel, distinctness may
+	 * be provable from them.
+	 */
+	if (rel->uniquekeys != NIL)
+		return true;
+	/* Otherwise we only know about baserels ... */
 	if (rel->reloptkind != RELOPT_BASEREL)
 		return false;
 	if (rel->rtekind == RTE_RELATION)
@@ -1179,6 +1185,16 @@ rel_is_distinct_for(PlannerInfo *root, RelOptInfo *rel, List *clause_list,
 					List **extra_clauses)
 {
 	/*
+	 * UniqueKey fast path: if some key's expressions are all covered by the
+	 * clauses, the rel is distinct for them.
+	 */
+	if (extra_clauses == NULL &&
+		uniquekeys_match_join_clauses(root, rel, clause_list))
+		return true;
+
+	/*
+	 * The fallback proofs below handle base relations only.
+	 *
 	 * We could skip a couple of tests here if we assume all callers checked
 	 * rel_supports_distinctness first, but it doesn't seem worth taking any
 	 * risk for.
diff --git a/src/backend/optimizer/plan/planner.c b/src/backend/optimizer/plan/planner.c
index 3225185d16f..2b8755bcf25 100644
--- a/src/backend/optimizer/plan/planner.c
+++ b/src/backend/optimizer/plan/planner.c
@@ -2157,6 +2157,13 @@ grouping_planner(PlannerInfo *root, double tuple_fraction,
 	final_rel->useridiscurrent = current_rel->useridiscurrent;
 	final_rel->fdwroutine = current_rel->fdwroutine;
 
+	/*
+	 * LockRows/Limit/ModifyTable never duplicate rows, so the final rel is
+	 * distinct over whatever the current rel was.  Carrying the keys here
+	 * lets a parent query reuse them.
+	 */
+	final_rel->uniquekeys = current_rel->uniquekeys;
+
 	/*
 	 * Generate paths for the final_rel.  Insert all surviving paths, with
 	 * LockRows, Limit, and/or ModifyTable steps added if needed.
@@ -4057,6 +4064,7 @@ create_grouping_paths(PlannerInfo *root,
 	RelOptInfo *grouped_rel;
 	RelOptInfo *partially_grouped_rel;
 	AggClauseCosts agg_costs;
+	bool		grouping_is_noop;
 
 	MemSet(&agg_costs, 0, sizeof(AggClauseCosts));
 	get_agg_clause_costs(root, AGGSPLIT_SIMPLE, &agg_costs);
@@ -4068,14 +4076,38 @@ create_grouping_paths(PlannerInfo *root,
 	grouped_rel = make_grouping_rel(root, input_rel, target,
 									target_parallel_safe, parse->havingQual);
 
-	/*
-	 * Create either paths for a degenerate grouping or paths for ordinary
-	 * grouping, as appropriate.
-	 */
-	if (is_degenerate_grouping(root))
+	grouping_is_noop = uniquekeys_grouping_is_noop(root, input_rel);
+
+	if (grouping_is_noop)
+	{
+		/*
+		 * The input relation is provably distinct over the grouping columns
+		 * and no aggregation work is needed, each input row forms a group all
+		 * by itself, so grouping is a no-op: just use the input paths as they
+		 * are, projecting the desired target.
+		 */
+		foreach_ptr(Path, path, input_rel->pathlist)
+		{
+			/*
+			 * The input paths may already be ProjectionPaths, and we mustn't
+			 * stack another rel's ProjectionPath atop one.  Just project
+			 * directly from the input's subpath.
+			 */
+			if (IsA(path, ProjectionPath))
+				path = ((ProjectionPath *) path)->subpath;
+
+			add_path(grouped_rel, (Path *)
+					 create_projection_path(root, grouped_rel, path, target));
+		}
+	}
+	else if (is_degenerate_grouping(root))
+	{
+		/* Create paths for a degenerate grouping */
 		create_degenerate_grouping_paths(root, input_rel, grouped_rel);
+	}
 	else
 	{
+		/* Create paths for ordinary grouping */
 		int			flags = 0;
 		GroupPathExtraData extra;
 
@@ -4148,6 +4180,11 @@ create_grouping_paths(PlannerInfo *root,
 	}
 
 	set_cheapest(grouped_rel);
+
+	/* Deduce the grouped rel's unique keys */
+	populate_grouped_rel_uniquekeys(root, grouped_rel, input_rel,
+									grouping_is_noop);
+
 	return grouped_rel;
 }
 
@@ -4824,6 +4861,12 @@ create_window_paths(PlannerInfo *root,
 	window_rel->useridiscurrent = input_rel->useridiscurrent;
 	window_rel->fdwroutine = input_rel->fdwroutine;
 
+	/*
+	 * Window functions don't change the set of rows, so uniqueness carries
+	 * over.
+	 */
+	window_rel->uniquekeys = input_rel->uniquekeys;
+
 	/*
 	 * Consider computing window functions starting from the existing
 	 * cheapest-total path (which will likely require a sort) as well as any
@@ -5054,6 +5097,7 @@ create_distinct_paths(PlannerInfo *root, RelOptInfo *input_rel,
 					  PathTarget *target)
 {
 	RelOptInfo *distinct_rel;
+	bool		distinct_is_noop;
 
 	/* For now, do all work in the (DISTINCT, NULL) upperrel */
 	distinct_rel = fetch_upper_rel(root, UPPERREL_DISTINCT, NULL);
@@ -5075,11 +5119,37 @@ create_distinct_paths(PlannerInfo *root, RelOptInfo *input_rel,
 	distinct_rel->useridiscurrent = input_rel->useridiscurrent;
 	distinct_rel->fdwroutine = input_rel->fdwroutine;
 
-	/* build distinct paths based on input_rel's pathlist */
-	create_final_distinct_paths(root, input_rel, distinct_rel);
+	distinct_is_noop = uniquekeys_distinct_is_noop(root, input_rel);
 
-	/* now build distinct paths based on input_rel's partial_pathlist */
-	create_partial_distinct_paths(root, input_rel, distinct_rel, target);
+	if (distinct_is_noop)
+	{
+		/*
+		 * The input relation is provably distinct over the DISTINCT columns
+		 * already, so no de-duplication step is required: just use the input
+		 * paths as they are, projecting the desired target.
+		 */
+		foreach_ptr(Path, path, input_rel->pathlist)
+		{
+			/*
+			 * The input paths may already be ProjectionPaths, and we mustn't
+			 * stack another rel's ProjectionPath atop one.  Just project
+			 * directly from the input's subpath.
+			 */
+			if (IsA(path, ProjectionPath))
+				path = ((ProjectionPath *) path)->subpath;
+
+			add_path(distinct_rel, (Path *)
+					 create_projection_path(root, distinct_rel, path, target));
+		}
+	}
+	else
+	{
+		/* build distinct paths based on input_rel's pathlist */
+		create_final_distinct_paths(root, input_rel, distinct_rel);
+
+		/* now build distinct paths based on input_rel's partial_pathlist */
+		create_partial_distinct_paths(root, input_rel, distinct_rel, target);
+	}
 
 	/* Give a helpful error if we failed to create any paths */
 	if (distinct_rel->pathlist == NIL)
@@ -5108,6 +5178,10 @@ create_distinct_paths(PlannerInfo *root, RelOptInfo *input_rel,
 	/* Now choose the best path(s) */
 	set_cheapest(distinct_rel);
 
+	/* Deduce the distinct rel's unique keys */
+	populate_distinct_rel_uniquekeys(root, distinct_rel, input_rel,
+									 distinct_is_noop);
+
 	return distinct_rel;
 }
 
@@ -5600,6 +5674,11 @@ create_ordered_paths(PlannerInfo *root,
 	ordered_rel->useridiscurrent = input_rel->useridiscurrent;
 	ordered_rel->fdwroutine = input_rel->fdwroutine;
 
+	/*
+	 * Sorting doesn't change the set of rows, so uniqueness carries over.
+	 */
+	ordered_rel->uniquekeys = input_rel->uniquekeys;
+
 	foreach(lc, input_rel->pathlist)
 	{
 		Path	   *input_path = (Path *) lfirst(lc);
@@ -8666,6 +8745,7 @@ create_unique_paths(PlannerInfo *root, RelOptInfo *rel, SpecialJoinInfo *sjinfo)
 	List	   *sortPathkeys = NIL;
 	List	   *groupClause = NIL;
 	MemoryContext oldcontext;
+	bool		unique_is_noop;
 
 	/* Caller made a mistake if SpecialJoinInfo is the wrong one */
 	Assert(sjinfo->jointype == JOIN_SEMI);
@@ -8713,6 +8793,11 @@ create_unique_paths(PlannerInfo *root, RelOptInfo *rel, SpecialJoinInfo *sjinfo)
 	unique_rel->cheapest_total_path = NULL;
 	unique_rel->cheapest_parameterized_paths = NIL;
 
+	/*
+	 * clear unique keys
+	 */
+	unique_rel->uniquekeys = NIL;
+
 	/*
 	 * Build the target list for the unique rel.  We also build the pathkeys
 	 * that represent the ordering requirements for the sort-based
@@ -8897,17 +8982,52 @@ create_unique_paths(PlannerInfo *root, RelOptInfo *rel, SpecialJoinInfo *sjinfo)
 		unique_rel->reltarget = create_pathtarget(root, newtlist);
 	}
 
-	/* build unique paths based on input rel's pathlist */
-	create_final_unique_paths(root, rel, sortPathkeys, groupClause,
-							  sjinfo, unique_rel);
+	unique_is_noop = uniquekeys_uniquification_is_noop(root, rel, sjinfo);
+
+	if (unique_is_noop)
+	{
+		/*
+		 * The input relation is already provably distinct over the columns to
+		 * be unique-ified, so no de-duplication step is required: just use
+		 * the input paths as they are, projecting the new target.
+		 */
+		Path	   *cheapest_input_path = rel->cheapest_total_path;
+
+		unique_rel->rows = rel->rows;
+
+		foreach_ptr(Path, input_path, rel->pathlist)
+		{
+			/*
+			 * Ignore parameterized paths that are not the cheapest-total
+			 * path, as in create_final_unique_paths.
+			 */
+			if (input_path->param_info &&
+				input_path != cheapest_input_path)
+				continue;
+
+			add_path(unique_rel, (Path *)
+					 create_projection_path(root, unique_rel, input_path,
+											unique_rel->reltarget));
+		}
+
+	}
+	else
+	{
+		/* build unique paths based on input rel's pathlist */
+		create_final_unique_paths(root, rel, sortPathkeys, groupClause,
+								  sjinfo, unique_rel);
 
-	/* build unique paths based on input rel's partial_pathlist */
-	create_partial_unique_paths(root, rel, sortPathkeys, groupClause,
-								sjinfo, unique_rel);
+		/* build unique paths based on input rel's partial_pathlist */
+		create_partial_unique_paths(root, rel, sortPathkeys, groupClause,
+									sjinfo, unique_rel);
+	}
 
 	/* Now choose the best path(s) */
 	set_cheapest(unique_rel);
 
+	populate_unique_rel_uniquekeys(root, unique_rel, rel, sjinfo,
+								   unique_is_noop);
+
 	/*
 	 * There shouldn't be any partial paths for the unique relation;
 	 * otherwise, we won't be able to properly guarantee uniqueness.
diff --git a/src/backend/optimizer/util/relnode.c b/src/backend/optimizer/util/relnode.c
index 687e923c46c..9e1afe4ecee 100644
--- a/src/backend/optimizer/util/relnode.c
+++ b/src/backend/optimizer/util/relnode.c
@@ -289,6 +289,7 @@ build_simple_rel(PlannerInfo *root, int relid, RelOptInfo *parent)
 	rel->fdw_private = NULL;
 	rel->unique_for_rels = NIL;
 	rel->non_unique_for_rels = NIL;
+	rel->uniquekeys = NIL;
 	rel->unique_rel = NULL;
 	rel->unique_pathkeys = NIL;
 	rel->unique_groupclause = NIL;
@@ -878,6 +879,7 @@ build_join_rel(PlannerInfo *root,
 	joinrel->fdw_private = NULL;
 	joinrel->unique_for_rels = NIL;
 	joinrel->non_unique_for_rels = NIL;
+	joinrel->uniquekeys = NIL;
 	joinrel->unique_rel = NULL;
 	joinrel->unique_pathkeys = NIL;
 	joinrel->unique_groupclause = NIL;
@@ -988,6 +990,9 @@ build_join_rel(PlannerInfo *root,
 	build_joinrel_partition_info(root, joinrel, outer_rel, inner_rel, sjinfo,
 								 restrictlist);
 
+	populate_joinrel_uniquekeys(root, joinrel, outer_rel, inner_rel,
+								sjinfo, restrictlist);
+
 	/* Add the joinrel to the PlannerInfo. */
 	add_join_rel(root, joinrel);
 
diff --git a/src/include/nodes/pathnodes.h b/src/include/nodes/pathnodes.h
index 27a2c6815b7..6343dd31e65 100644
--- a/src/include/nodes/pathnodes.h
+++ b/src/include/nodes/pathnodes.h
@@ -534,6 +534,14 @@ struct PlannerInfo
 	/* set operator pathkeys, if any */
 	List	   *setop_pathkeys;
 
+	/*
+	 * Indexes in PlannerInfo's eq_classes list of ECs that are worth tracking
+	 * in UniqueKeys.
+	 */
+	Bitmapset  *interesting_unique_ecs;
+	/* true once interesting_unique_ecs has been computed */
+	bool		interesting_unique_ecs_valid;
+
 	/* Canonicalised partition schemes used in the query. */
 	List	   *part_schemes pg_node_attr(read_write_ignore);
 
@@ -875,6 +883,10 @@ typedef struct PartitionSchemeData *PartitionScheme;
  *					other rels for which we have tried and failed to prove
  *					this one unique
  *
+ * In addition, uniquekeys is a list of UniqueKey nodes describing expression
+ * sets over which this relation is known to be distinct.  It is populated
+ * bottom-up, for base rels and join rels alike; see uniquekeys.c.
+ *
  * Three fields are used to cache information about unique-ification of this
  * relation.  This is used to support semijoins where the relation appears on
  * the RHS: the relation is first unique-ified, and then a regular join is
@@ -1125,6 +1137,9 @@ typedef struct RelOptInfo
 	/* known not unique for these set(s) */
 	List	   *non_unique_for_rels;
 
+	/* list of UniqueKey: expression sets this rel is distinct over */
+	List	   *uniquekeys;
+
 	/*
 	 * information about unique-ification of this relation
 	 */
@@ -1674,6 +1689,7 @@ typedef struct EquivalenceClass
 	Index		ec_sortref;		/* originating sortclause label, or 0 */
 	Index		ec_min_security;	/* minimum security_level in ec_sources */
 	Index		ec_max_security;	/* maximum security_level in ec_sources */
+	int			ec_index;		/* position of this EC in root->eq_classes */
 	struct EquivalenceClass *ec_merged; /* set if merged into another EC */
 } EquivalenceClass;
 
@@ -1816,6 +1832,32 @@ typedef struct PathKey
 	bool		pk_nulls_first; /* do NULLs come before normal values? */
 } PathKey;
 
+/*
+ * UniqueKeys
+ *
+ * Asserts that a relation cannot emit two rows that are equal on the
+ * values of one expression from each of the EquivalenceClasses identified
+ * by eclass_indexes (indexes into root->eq_classes).  An empty set means
+ * the relation emits at most one row.
+ *
+ * If "nullable" is false, the proof is NULL-aware (no two rows are equal
+ * even treating NULLs as equal), so the key can justify removing a
+ * DISTINCT or GROUP BY step.  If it is true, uniqueness is only guaranteed
+ * among rows whose key expressions are all non-NULL, which still suffices
+ * for proofs based on strict join clauses, such as inner_unique detection.
+ */
+typedef struct UniqueKey
+{
+	pg_node_attr(no_copy_equal, no_read, no_query_jumble)
+
+	NodeTag		type;
+
+	/* indexes into root->eq_classes of the key's expressions */
+	Bitmapset  *eclass_indexes;
+	/* is uniqueness only guaranteed among non-NULL key values? */
+	bool		nullable;
+} UniqueKey;
+
 /*
  * Contains an order of group-by clauses and the corresponding list of
  * pathkeys.
diff --git a/src/include/optimizer/paths.h b/src/include/optimizer/paths.h
index 17f2099ec3b..11a577772cc 100644
--- a/src/include/optimizer/paths.h
+++ b/src/include/optimizer/paths.h
@@ -74,6 +74,8 @@ extern void create_partial_bitmap_paths(PlannerInfo *root, RelOptInfo *rel,
 										Path *bitmapqual);
 extern void generate_partitionwise_join_paths(PlannerInfo *root,
 											  RelOptInfo *rel);
+extern void add_paths_to_append_rel(PlannerInfo *root, RelOptInfo *rel,
+									List *live_childrels);
 
 /*
  * indxpath.c
@@ -245,6 +247,7 @@ extern List *build_expression_pathkey(PlannerInfo *root, Expr *expr,
 extern List *convert_subquery_pathkeys(PlannerInfo *root, RelOptInfo *rel,
 									   List *subquery_pathkeys,
 									   List *subquery_tlist);
+extern Var *find_var_for_subquery_tle(RelOptInfo *rel, TargetEntry *tle);
 extern List *build_join_pathkeys(PlannerInfo *root,
 								 RelOptInfo *joinrel,
 								 JoinType jointype,
@@ -283,7 +286,38 @@ extern List *append_pathkeys(List *target, List *source);
 extern PathKey *make_canonical_pathkey(PlannerInfo *root,
 									   EquivalenceClass *eclass, Oid opfamily,
 									   CompareType cmptype, bool nulls_first);
-extern void add_paths_to_append_rel(PlannerInfo *root, RelOptInfo *rel,
-									List *live_childrels);
+
+/*
+ * uniquekeys.c
+ *	  routines to deduce what expression sets a relation is distinct over
+ */
+extern void populate_baserel_uniquekeys(PlannerInfo *root, RelOptInfo *rel);
+extern void populate_joinrel_uniquekeys(PlannerInfo *root, RelOptInfo *joinrel,
+										RelOptInfo *outerrel,
+										RelOptInfo *innerrel,
+										SpecialJoinInfo *sjinfo,
+										List *restrictlist);
+extern void populate_grouped_rel_uniquekeys(PlannerInfo *root,
+											RelOptInfo *grouped_rel,
+											RelOptInfo *input_rel,
+											bool is_noop);
+extern void populate_distinct_rel_uniquekeys(PlannerInfo *root,
+											 RelOptInfo *distinct_rel,
+											 RelOptInfo *input_rel,
+											 bool is_noop);
+extern void populate_unique_rel_uniquekeys(PlannerInfo *root,
+										   RelOptInfo *unique_rel,
+										   RelOptInfo *input_rel,
+										   SpecialJoinInfo *sjinfo,
+										   bool is_noop);
+extern bool uniquekeys_distinct_is_noop(PlannerInfo *root,
+										RelOptInfo *input_rel);
+extern bool uniquekeys_grouping_is_noop(PlannerInfo *root,
+										RelOptInfo *input_rel);
+extern bool uniquekeys_match_join_clauses(PlannerInfo *root, RelOptInfo *rel,
+										  List *clause_list);
+extern bool uniquekeys_uniquification_is_noop(PlannerInfo *root,
+											  RelOptInfo *rel,
+											  SpecialJoinInfo *sjinfo);
 
 #endif							/* PATHS_H */
diff --git a/src/test/regress/parallel_schedule b/src/test/regress/parallel_schedule
index 8fa0a6c47fb..9920877c107 100644
--- a/src/test/regress/parallel_schedule
+++ b/src/test/regress/parallel_schedule
@@ -63,6 +63,8 @@ test: sanity_check
 # ----------
 test: select_into select_distinct select_distinct_on select_implicit select_having subselect union case join aggregates transactions random portals arrays btree_index hash_index update delete namespace prepared_xacts
 
+test: uniquekeys
+
 # ----------
 # Another group of parallel tests
 # ----------
diff --git a/src/test/regress/sql/aggregates.sql b/src/test/regress/sql/aggregates.sql
index b788152f0c2..e854948e0a2 100644
--- a/src/test/regress/sql/aggregates.sql
+++ b/src/test/regress/sql/aggregates.sql
@@ -517,18 +517,18 @@ create temp table t2 (x int, y int, z int, primary key (x, y));
 create temp table t3 (a int, b int, c int, primary key(a, b) deferrable);
 
 -- Non-primary-key columns can be removed from GROUP BY
-explain (costs off) select * from t1 group by a,b,c,d;
+explain (costs off) select count(*) from t1 group by a,b,c,d;
 
 -- No removal can happen if the complete PK is not present in GROUP BY
 explain (costs off) select a,c from t1 group by a,c,d;
 
 -- Test removal across multiple relations
-explain (costs off) select *
+explain (costs off) select count(*)
 from t1 inner join t2 on t1.a = t2.x and t1.b = t2.y
 group by t1.a,t1.b,t1.c,t1.d,t2.x,t2.y,t2.z;
 
 -- Test case where t1 can be optimized but not t2
-explain (costs off) select t1.*,t2.x,t2.z
+explain (costs off) select t1.*,t2.x,t2.z,count(*)
 from t1 inner join t2 on t1.a = t2.x and t1.b = t2.y
 group by t1.a,t1.b,t1.c,t1.d,t2.x,t2.z;
 
@@ -538,10 +538,10 @@ explain (costs off) select * from t3 group by a,b,c;
 create temp table t1c () inherits (t1);
 
 -- Ensure we don't remove any columns when t1 has a child table
-explain (costs off) select * from t1 group by a,b,c,d;
+explain (costs off) select count(*) from t1 group by a,b,c,d;
 
 -- Okay to remove columns if we're only querying the parent.
-explain (costs off) select * from only t1 group by a,b,c,d;
+explain (costs off) select count(*) from only t1 group by a,b,c,d;
 
 create temp table p_t1 (
   a int,
@@ -554,31 +554,31 @@ create temp table p_t1_1 partition of p_t1 for values in(1);
 create temp table p_t1_2 partition of p_t1 for values in(2);
 
 -- Ensure we can remove non-PK columns for partitioned tables.
-explain (costs off) select * from p_t1 group by a,b,c,d;
+explain (costs off) select count(*) from p_t1 group by a,b,c,d;
 
 create unique index t2_z_uidx on t2(z);
 
 -- Ensure we don't remove any columns from the GROUP BY for a unique
 -- index on a NULLable column.
-explain (costs off) select y,z from t2 group by y,z;
+explain (costs off) select y,z,count(*) from t2 group by y,z;
 
 -- Make the column NOT NULL and ensure we remove the redundant column
 alter table t2 alter column z set not null;
-explain (costs off) select y,z from t2 group by y,z;
+explain (costs off) select y,z,count(*) from t2 group by y,z;
 
 -- When there are multiple supporting unique indexes and the GROUP BY contains
 -- columns to cover all of those, ensure we pick the index with the least
 -- number of columns so that we can remove more columns from the GROUP BY.
-explain (costs off) select x,y,z from t2 group by x,y,z;
+explain (costs off) select x,y,z,count(*) from t2 group by x,y,z;
 
 -- As above but try ordering the columns differently to ensure we get the
 -- same result.
-explain (costs off) select x,y,z from t2 group by z,x,y;
+explain (costs off) select x,y,z,count(*) from t2 group by z,x,y;
 
 -- Ensure we don't use a partial index as proof of functional dependency
 drop index t2_z_uidx;
 create index t2_z_uidx on t2 (z) where z > 0;
-explain (costs off) select y,z from t2 group by y,z;
+explain (costs off) select y,z,count(*) from t2 group by y,z;
 
 -- A unique index defined as NULLS NOT DISTINCT does not need a supporting NOT
 -- NULL constraint on the indexed columns.  Ensure the redundant columns are
@@ -586,7 +586,7 @@ explain (costs off) select y,z from t2 group by y,z;
 drop index t2_z_uidx;
 alter table t2 alter column z drop not null;
 create unique index t2_z_uidx on t2(z) nulls not distinct;
-explain (costs off) select y,z from t2 group by y,z;
+explain (costs off) select y,z,count(*) from t2 group by y,z;
 
 drop table t1 cascade;
 drop table t2;
diff --git a/src/test/regress/sql/uniquekeys.sql b/src/test/regress/sql/uniquekeys.sql
new file mode 100644
index 00000000000..cbfc020fa0c
--- /dev/null
+++ b/src/test/regress/sql/uniquekeys.sql
@@ -0,0 +1,118 @@
+--
+-- UNIQUEKEYS
+--
+-- Tests for the planner's inference of what a relation is distinct over
+--
+
+create table uk_t1 (a int, b int, c int, d int, primary key (a, b));
+create table uk_t2 (id int primary key, v int);
+create table uk_t3 (id int primary key, v int);
+create table uk_t4 (id int primary key, v int);
+create table uk_tn (nu int unique, nz int, k int);
+create unique index uk_tn_nz on uk_tn (nz) nulls not distinct;
+create table uk_def (id int, primary key (id) deferrable);
+create table uk_part (a int, b int);
+create unique index uk_part_a on uk_part (a) where b > 0;
+
+--
+-- Base relation keys
+--
+-- a non-nullable multi-column key removes the DISTINCT
+explain (costs off)
+select distinct a, b from uk_t1;
+-- a key column equated to a constant is dropped from the key
+explain (costs off)
+select distinct b from uk_t1 where a = 5;
+-- a nullable unique column is not enough on its own
+explain (costs off)
+select distinct nu from uk_tn;
+-- a NULLS NOT DISTINCT unique column is a full key
+explain (costs off)
+select distinct nz from uk_tn;
+-- a strict restriction makes the nullable unique column non-null
+explain (costs off)
+select distinct nu from uk_tn where nu > 0;
+-- a deferrable unique index is unusable
+explain (costs off)
+select distinct id from uk_def;
+-- a partial unique index is unusable
+explain (costs off)
+select distinct a from uk_part where b > 0;
+
+--
+-- Subquery-in-FROM keys
+--
+-- a DISTINCT inside is translated
+explain (costs off)
+select distinct a, b from (select distinct a, b from uk_t1) s;
+-- a GROUP BY inside is translated
+explain (costs off)
+select distinct a, b from (select a, b from uk_t1 group by a, b) s;
+-- a plain aggregate emits a single row
+explain (costs off)
+select distinct m from (select max(a) as m from uk_t1) s;
+-- a key from a base index carried up through a join
+explain (costs off)
+select distinct x from (select uk_t2.id as x from uk_t2 join uk_t3 on uk_t2.id = uk_t3.id offset 0) s;
+-- a non-ALL set operation is distinct over its whole output row (the set
+-- operation's own dedup Aggregate ends up below the join)
+explain (costs off)
+select distinct s.a, s.b from (select a, b from uk_t1 union select a, b from uk_t1) s join uk_t2 on s.a = uk_t2.id;
+-- UNION ALL is not distinct, so the DISTINCT Aggregate stays above the join
+explain (costs off)
+select distinct s.a, s.b from (select a, b from uk_t1 union all select a, b from uk_t1) s join uk_t2 on s.a = uk_t2.id;
+
+--
+-- Join relation keys
+--
+-- an inner join preserves a side's key when the other side is unique for the
+-- join clauses
+explain (costs off)
+select distinct uk_t3.id from uk_t2 join uk_t3 on uk_t2.id = uk_t3.id;
+-- combination: the union of a key from each side (here a cross join)
+explain (costs off)
+select distinct uk_t2.id, uk_t3.id from uk_t2 cross join uk_t3;
+-- a left join makes the RHS key nullable, so the DISTINCT is kept
+explain (costs off)
+select distinct uk_t3.id from uk_t2 left join uk_t3 on uk_t2.id = uk_t3.id;
+-- a left join preserves the non-nullable LHS key
+explain (costs off)
+select distinct uk_t2.id, uk_t3.v from uk_t2 left join uk_t3 on uk_t2.id = uk_t3.id;
+-- a semijoin preserves the LHS key
+explain (costs off)
+select distinct a, b from uk_t1 where exists (select 1 from uk_t2 where uk_t2.id = uk_t1.c);
+-- an inner join's strict clause strengthens a nullable key to non-nullable
+explain (costs off)
+select distinct nu from uk_tn join uk_t2 on uk_tn.nu = uk_t2.id;
+-- the strict clause does not cover the key column, so no strengthening
+explain (costs off)
+select distinct nu from uk_tn join uk_t2 on uk_tn.k = uk_t2.id;
+-- a full join yields no key
+explain (costs off)
+select distinct uk_t2.id from uk_t2 full join uk_t3 on uk_t2.id = uk_t3.id;
+-- a key survives stacked outer joins
+explain (costs off)
+select distinct uk_t2.id, y.v from uk_t2 left join uk_t3 x on uk_t2.id = x.id left join uk_t3 y on x.id = y.id;
+-- uniqueness of a multi-relation inner side is proven from that joinrel's key
+explain (verbose, costs off)
+select distinct uk_t2.id from uk_t2 left join (uk_t3 join uk_t4 on uk_t3.id = uk_t4.id) on uk_t2.v = uk_t3.id;
+-- uniqueness of a semijoin's multi-relation RHS skips the unique-ification step
+explain (costs off)
+select * from uk_t2, uk_t3 where (uk_t2.id, uk_t3.id) in (select t1.a, t1.b from uk_t1 t1 join uk_tn on t1.a = nu and b = nz);
+
+--
+-- Grouping step: grouping by a superset of a key is a no-op (with no aggregates)
+--
+explain (costs off)
+select a, b from uk_t1 group by a, b, c;
+-- grouping by a non-key set is not a no-op
+explain (costs off)
+select a, c from uk_t1 group by a, c;
+
+drop table uk_t1;
+drop table uk_t2;
+drop table uk_t3;
+drop table uk_t4;
+drop table uk_tn;
+drop table uk_def;
+drop table uk_part;
diff --git a/src/tools/pgindent/typedefs.list b/src/tools/pgindent/typedefs.list
index 56c1f997f88..c48e13e274d 100644
--- a/src/tools/pgindent/typedefs.list
+++ b/src/tools/pgindent/typedefs.list
@@ -3331,6 +3331,7 @@ UVersionInfo
 UnicodeNormalizationForm
 UnicodeNormalizationQC
 Unique
+UniqueKey
 UniquePath
 UniqueRelInfo
 UniqueState
-- 
2.39.5 (Apple Git-154)

